#!/usr/bin/perl -X
#
# written by Hans-Jörg Bibiko - bibiko@eva.mpg.de

use utf8;

binmode STDIN, ':utf8';
binmode STDOUT, ':utf8';

$out_temp = $ENV{'TM_BUNDLE_SUPPORT'} . "/bin/HSDOut";

open(DIALOG,"<$out_temp");
binmode DIALOG, ':utf8';

$btn = 1;
$regexp = $igncase = $wrap = 0;
$re = "";

while(<DIALOG>){
	chomp;
	($a,$btn) = split(/\t/) if(/returnCode\t/);
	($a,$regexp) = split(/\t/) if(/regExp\t/);
	($a,$igncase) = split(/\t/) if(/ignCase\t/);
	($a,$wrap) = split(/\t/) if(/wrapLines\t/);
	($a,$re) = split(/\t/) if(/searchString\t/);	
}
close(DIALOG);

$limit = 3000;
$limit = $ENV{'TM_HYPERSEARCH_LIMIT'} if (defined($ENV{'TM_HYPERSEARCH_LIMIT'}));
$limit += 0;

$fallbacklimit = 30000; # how many matches are allowed for one line

$tabs = (defined($ENV{'TM_TAB_SIZE'})) ? $ENV{'TM_TAB_SIZE'} + 0 : 1;

$cnt = 0;

$btn = 1 if(!length($re));

if(!$regexp){
	$r = quotemeta($re);
	$r = "($r)";
} else {
	$re =~ s/\\n.*/\$/;
	$r = $re;
	$r =~ s/\\\(//g;
	$r =~ s/\\\)//g;
	$r = ($r !~ m/\(/) ? "($re)" : $re;
}

$r =~ s/\\\(/￲/g;
$r =~ s/\\\)/￳/g;
$r =~ s/(.*?)\((.*?)\)(.*)/($1)($2)($3)/g;
$r =~ s/￲/\\(/g;
$r =~ s/￳/\\)/g;

$wr = "normal";
$wr = "nowrap" if(!$wrap);

$mtch = 0;

if(!$btn) {
	if($r !~ /\\n/) {
		if($igncase) {
			while (<>) {
				chomp;
				if(/$r/goi) {
					$cnt++;
					if ($cnt>$limit){
						print "<tr><td></td><td><font color=red>Search canceled! Too many matches according to TM_HYPERSEARCH_LIMIT!</font></td></tr>";
						last;
					}
					$line = $temp1 = $_;
					@cols = ();
					$safetyCnt = 0;
					while($line =~ /$r/goi) { push(@cols, pos($line) - length($&) + 1 + index($&,$2)); }
					# delimter for highlighting U+FFF3;
					#$mtch += $line =~ s/$r/substr($&,0,index($&,$1)).'￳'.$1.'￳'.substr($&,index($&,$1)+length($1),length($&)-index($&,$1)-length($1))/gei;
					$mtch += $line =~ s/$r/$1￳$2￳$3/goi;
					$_ = $line;
					s/&/&amp;/g;
					s/</&lt;/g;
					s/>/&gt;/g;
					$ps = 0;
					$safetyCnt = 0;
					while(m/￳(.*?)￳/g){
						s/￳(.*?)￳/<\/a><a href='txmt:\/\/open?line=$.&column=$cols[$ps++]' style='text-decoration:none'><b><i><u>$1<\/u><\/i><\/b>/;
						pos();
						if($safetyCnt++>$fallbacklimit){
							$_="Safety Fallback was activated! Too many matches for line $.!";
							last;
						}
					}
					$col = sprintf("%02d", $cols[0]);
					while(s/  / &nbsp;/g) {1}
					s/\t/\t /g;
					while (s/\t+/'&nbsp;' x (length($&) * $tabs - length($`) % $tabs)/e) { 1 }
					print "<tr><td align='right' style='color:grey'>$.:$col</td><td style='padding-left:2mm;border-left:solid 1px lightgrey;white-space:$wr'><a href='txmt:\/\/open?line=$.&column=$cols[0]' style='text-decoration:none'>$_<\/a></td></tr>\n"; 
				}
			}
			print STDERR $mtch;
		} else {
			while (<>) {
				chomp;
				if(/$r/go) { 
					$cnt++;
					if ($cnt>$limit){
						print "<tr><td></td><td><font color=red>Search canceled! Too many matches according to TM_HYPERSEARCH_LIMIT!</font></td></tr>";
						last;
					}
					$line = $temp1 = $_;
					@cols = ();
					$safetyCnt = 0;
					while($line =~ /$r/g) { push(@cols, pos($line) - length($&) + 1 + index($&,$1)); }
					# delimter for highlighting U+FFF3;
					#$mtch += $line =~ s/$r/substr($&,0,index($&,$1)).'￳'.$1.'￳'.substr($&,index($&,$1)+length($1),length($&)-index($&,$1)-length($1))/ge;
					$mtch += $line =~ s/$r/$1￳$2￳$3/goi;
					$_ = $line;
					s/&/&amp;/g;
					s/</&lt;/g;
					s/>/&gt;/g;
					$ps = 0;
					$safetyCnt = 0;
					while(m/￳(.*?)￳/g){
						s/￳(.*?)￳/<\/a><a href='txmt:\/\/open?line=$.&column=$cols[$ps++]' style='text-decoration:none'><b><i><u>$1<\/u><\/i><\/b>/;
						pos();
						if($safetyCnt++>$fallbacklimit){
							$_="Safety Fallback was activated! Too many matches for line $.!";
							last;
						}
					}
					$col = sprintf("%02d", $cols[0]);
					while(s/  / &nbsp;/g) {1}
					s/\t/\t /g;
					while (s/\t+/'&nbsp;' x (length($&) * $tabs - length($`) % $tabs)/e) { 1 }
					print "<tr><td align='right' style='color:grey'>$.:$col</td><td style='padding-left:2mm;border-left:solid 1px lightgrey;white-space:$wr'><a href='txmt:\/\/open?line=$.&column=$cols[0]' style='text-decoration:none'>$_<\/a></td></tr>\n"; 
				}
			}
			print STDERR $mtch;
		}
	} else {
		#TODO
	}
}