#!/usr/bin/perl -X
#
# written by Hans-Jörg Bibiko - bibiko@eva.mpg.de

binmode STDIN, ':utf8';
binmode STDOUT, ':utf8';

$out_temp = $ENV{'TM_BUNDLE_SUPPORT'} . "/bin/HSDOut.plist";

open(DIALOG,"<$out_temp");
binmode DIALOG, ':utf8';

$out="";
$selText = <>;
$selText =~ s/\$$/\\n/;
$selText =~ s/\\t/\\t/g;
exit if(!$selText);

@hist = ();
$maxHist = 3;
$maxHist = ($ENV{'TM_HYPERSEARCH_HIST_LIMIT'} - 2) if (defined($ENV{'TM_HYPERSEARCH_HIST_LIMIT'}));
$maxHist = 3 if ($maxHist<3 || $maxHist>30);

$saveCnt = 0; # for safty reasons

while(<DIALOG>){
	chomp;
	if(m/<key>searchHist<\/key>/){
		$out .= "$_\n";
		$val = <DIALOG>;
		chomp($val);
		$out .= "$val\n";
		while($saveCnt<31){ # for safty reasons
			$saveCnt++;
			$val = <DIALOG>;
			chomp($val);
			if($val =~ m/<\/array>/){
				$flag = 1;
				$histMaxCnt = $#hist;
				$histCnt = ($maxHist<$histMaxCnt) ? $maxHist : $histMaxCnt;
				@histn = @hist[0 .. $histCnt];
				for(@histn){ 
					$flag = 0 if ($_ eq $selText);
				}
				if($flag){
					unshift(@histn, $selText);
				} else {
					push(@histn, $hist[$histCnt+1]) if($maxHist<$histMaxCnt);
				}
				$out .= "\t\t<string>" . join("</string>\n\t\t<string>", @histn) ."</string>\n";
				$out .= "$val\n";
				last;
			}
			$val =~ m/(.*?<string>)(.*?)(<\/string>)/g;
			push(@hist, $2) if(length($2));
		}
	} else {
		$out .= "$_\n";
	}
}

close(DIALOG);
open(OUT,">$out_temp");
binmode OUT, ':utf8';
print OUT $out;
close(OUT);